//TO DO

/*
check if all drops selected before submit / alert
condition if no results from search
reset for counter vars
image reload on research

*/

$(function() {


var results_xml=[];
var result_index;

var country;
var state;
var city;

var imageRefs = "";
var imageGrab;

var resultsTotal = 0;
var resultsCurrent;

var photoTotal = 20;

//popCountries(); (Bound to GWD load)




//Populate countries

window.popCountries=function(){

console.log("popCountries executed");

resetSelects();


	$.ajax({
		type: "POST",
		url:"http://www.inoventiv.com/ChristiesService/Inventory.asmx/GetCountries",
		data:"",
		dataType: "html",
		
		success: function(data) {
			data=convert(data);
			selectArea = $('#countrySelect');
			selectArea.empty();
			selectArea.append("<option value='none'>--Select A Country--</option>");
			$(data).find('Item').each(function(){
				country = $(this).find('AddrCountry').text();
				selectArea.append("<option value='"+country+"'>"+country+"</option>");
			});
		},
	});

}



//Populate states

window.popStates=function(){

console.log("popStates executed");
country = $('#countrySelect').val();
resetCities();

	$.ajax({
		type: "POST",
		url:"http://www.inoventiv.com/ChristiesService/Inventory.asmx/GetStates",
		data:"country="+country+"",
		dataType: "html",
		
		success: function(data) {
			data=convert(data);
			selectArea = $('#stateSelect');
			selectArea.empty();
			selectArea.append("<option value='none'>--Select A State--</option>");
			$(data).find('Item').each(function(){
				state = $(this).find('AddrState').text();
				selectArea.append("<option value='"+state+"'>"+state+"</option>");
			});
			if (state == ""){
				selectArea.empty();
				selectArea.append("<option value='none'>--Select A State--</option>");
				selectArea.append("<option value=''>SEARCH ALL STATES</option>");
			}
		},
	});

}



//Populate cities

window.popCities=function(){

console.log("popCities executed");

country = $('#countrySelect').val();
state = $('#stateSelect').val();

	$.ajax({
		type: "POST",
		url:"http://www.inoventiv.com/ChristiesService/Inventory.asmx/GetCities",
		data:"country="+country+"&state="+state+"",
		dataType: "html",
		
		success: function(data) {
			data=convert(data);
			selectArea = $('#citySelect');
			selectArea.empty();
			selectArea.append("<option value='none'>--Select A City--</option>");
			$(data).find('Item').each(function(){
				city = $(this).find('AddrCity').text();
				selectArea.append("<option value='"+city+"'>"+city+"</option>");
			});
		},
	});

}

window.lockInCity=function(){
	city = $('#citySelect').val();
}

window.resetCities=function(){
	$('#citySelect').empty();
	$('#citySelect').append("<option value='none'>--Select A City--</option>");
}


//Reset the dropdowns

window.resetSelects=function(){
	$('#stateSelect').empty();
	$('#stateSelect').append("<option value='none'>--Select A State--</option>");

	$('#citySelect').empty();
	$('#citySelect').append("<option value='none'>--Select A City--</option>");
}


//Search results

window.searchResults=function(){
console.log("searchResults executed");
	$.ajax({
		type: "POST",
		url:"http://www.inoventiv.com/ChristiesService/Inventory.asmx/GetListings",
		data:"country="+country+"&state="+state+"&city="+city+"",
		//data:"country=united states&state=new york&city=new york",
		dataType: "html",

		success: function(data) {
			data=convert(data);
			$(data).find('Item').each(function(){
				results_xml.push($(this));
				resultsTotal++;
			});
			result_index = 0;
			popResults();

		}

	});
}



//Populate the results

window.popResults=function(){

console.log("popResults executed");

		//wrap function in if statement conditional on resultsTotal > 0, else dont expand or pop results
		//gwd.actions.gwdDoubleclick.goToPage('gwd-ad', 'expanded-page'); <-- Currently called from GWD searchResults event
		

		resultsCurrent = parseInt(result_index + 1);		
		$('#resultsCounter').text("Showing result " + resultsCurrent + " of " + resultsTotal);
		
		$('#address').text($(results_xml[result_index]).find('Address').text());
		$('#price').text($(results_xml[result_index]).find('Price').text() + " USD");
		var localCurrency = $(results_xml[result_index]).find('LocalCurrency').text();
		$('#localPrice').text($(results_xml[result_index]).find('LocalPrice').text() + " " + localCurrency);
		$('#bedrooms').text("Bedrooms: " + $(results_xml[result_index]).find('Bedroom').text());
		$('#fullBaths').text("Full Baths: " + $(results_xml[result_index]).find('BathsFull').text());
		$('#partBaths').text("Partial Baths: " + $(results_xml[result_index]).find('BathsPartial').text());
		$('#interior').text("Interior: " + $(results_xml[result_index]).find('SqFeetInterior').text() + " sq/ft");
		$('#propType').text("Property Type: " + $(results_xml[result_index]).find('CodePropertyType').text());
		$('#agentName').text($(results_xml[result_index]).find('Agent1Name').text());
		$('#agentEmail').text($(results_xml[result_index]).find('Agent1Email').text());
		
		var detailsLink = $(results_xml[result_index]).find('AdvertiserListingURL').text();
		$('#details').attr("href", detailsLink);
		console.log(detailsLink);
		
		
		var agentPhoto = $(results_xml[result_index]).find('Agent1Photo').text();
		$('#agentImg').attr("src", agentPhoto);
		
		//Loop through the photo tags and concat the URLs, then sub in as source for gallery assets
		for (photoNum = 1; photoNum <= photoTotal; photoNum++){
			imageGrab = $(results_xml[result_index]).find('Photo'+photoNum).text();
			imageRefs = imageRefs + imageGrab + ",";
		}
		console.log(imageRefs);
		$('#photoGallery').attr("images", imageRefs);
		imageRefs = "";
		imageGrab = "";

}

//Tab through results

window.nextResult=function(){
	if (resultsCurrent < resultsTotal){
		result_index++;
		popResults();
	}
}
	 
window.prevResult=function(){
	if (resultsCurrent != 1){
		result_index--;
		popResults();
	}
}



//Tab through pics

window.nextPic=function(){
	if (extraPic != ""){
		photoNum++;
		extraPic = ($(results_xml[result_index]).find('photo'+photoNum).text());
		$('#propImg').attr("src", extraPic);
	}
}

window.prevPic=function(){
	if (photoNum > 1){
		photoNum--;
		extraPic = ($(results_xml[result_index]).find('photo'+photoNum).text());
		$('#propImg').attr("src", extraPic);
	}
}

//Reset necessary vars
window.resetSearch=function(){
	results_xml=[];
	result_index = 0;
 
	resultsTotal = 0;
	resultsCurrent = 0;
}


//Scrub the data
window.convert=function(data) {
	var returnstr=data;
     	var rep={
     		"&gt;":">",
     		"&lt;":"<"
     	};
		for(var i in rep){
     		var reg=RegExp(i,"g");
     		returnstr=returnstr.replace(reg,rep[i]);
     	}
			
		var xmlDoc=null;
		if (window.DOMParser){ 
			 var parser=new DOMParser();
			 xmlDoc=parser.parseFromString(returnstr,"text/xml");
		}
		else // Internet Explorer
		{
			xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
			xmlDoc.async=false;
			xmlDoc.loadXML(returnstr);
		}
		return $(xmlDoc);
}



});
